package dev.peerat.backend.utils;

import java.util.Properties;

import dev.peerat.backend.MailConfiguration;
import jakarta.mail.Message;
import jakarta.mail.MessagingException;
import jakarta.mail.PasswordAuthentication;
import jakarta.mail.Session;
import jakarta.mail.Transport;
import jakarta.mail.internet.InternetAddress;
import jakarta.mail.internet.MimeMessage;


public class Mail {
    public static void send(String toAddress, String subject, String text, MailConfiguration mailConfiguration) {

        Properties props = new Properties();
        props.put("mail.smtp.starttls.enable", "true");
        props.put("mail.smtp.auth", "true");
        props.put("mail.smtp.host", mailConfiguration.getSmtpHost());
        props.put("mail.smtp.port", mailConfiguration.getSmtpPort());

        Session session = Session.getInstance(props,
          new jakarta.mail.Authenticator() {
            protected PasswordAuthentication getPasswordAuthentication() {
                return new PasswordAuthentication(mailConfiguration.getUsername(), mailConfiguration.getPassword());
            }
          });

        try {

            Message message = new MimeMessage(session);
            message.setFrom(new InternetAddress(mailConfiguration.getFromAddress()));
            message.setRecipients(Message.RecipientType.TO,
                InternetAddress.parse(toAddress));
            message.setSubject(subject);
            message.setText(text);

            Transport.send(message);
        } catch (MessagingException e) {
            throw new RuntimeException(e);
        }
    }
}
